Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/releases/release-110.63/install.sh
ViewVC logotype

Diff of /config/releases/release-110.63/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

sml/branches/SMLNJ/config/install.sh revision 249, Sat Apr 17 18:57:03 1999 UTC sml/trunk/config/install.sh revision 1494, Thu May 20 03:09:17 2004 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/sh
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4    # Copyright (c) 2003 The Fellowship of SML/NJ
5  #  #
6  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
7  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
8  #  #
9    # Significant changes to take advantage of a new portable installer
10  #set -x  # script for everything after booting the interactive system.
   
11  #  #
12  # get the target list  # Author: Matthias Blume (blume@tti-c.org)
13  #  #
14  if [ ! -r config/targets ]; then  
15    echo "!!! no target list"  if [ x${INSTALL_QUIETLY} = xtrue ] ; then
16    exit 1;      export CM_VERBOSE=false
17  fi  fi
 . config/targets  
18    
19  #  vsay() {
20  # some OSs have make in strange places      if [ x${INSTALL_DEBUG} = xtrue ] ; then
21  #          echo "$@"
22  MAKE=make      elif [ x${INSTALL_QUIETLY} = xtrue ] ; then
23            :
24        else
25            echo "$@"
26        fi
27    }
28    
29    complain() {
30        echo "$@"
31        exit 1
32    }
33    
34    this=$0
35    
36    
37  #  #
38  # command for building SML libraries; this should be either  # create the preloads.standard file
 # "CM.recompile()" or "CM.stabilize true".  The latter builds  
 # stable libraries, which may be somewhat faster to use.  
39  #  #
40  #CM_MAKE_LIB="CM.recompile();"  if [ ! -r config/preloads ]; then
41  CM_MAKE_LIB="CM.stabilize true;"      complain "$this: !!! File config/preloads is missing."
42    fi
43    cp config/preloads preloads.standard
44    
45  #  #
46  # check for ksh  # Some OSs have make in strange places, but most of the time it is
47  #  # simply on the PATH:
 # ksh causes some people problems so we will always use /bin/sh  
48  #  #
49  #echo "checking for ksh"  MAKE=make
50  #if [ -x /bin/ksh ]; then  
 #  SHELL=/bin/ksh  
 #elif [ -x /usr/local/bin/ksh ]; then  
 #  SHELL=/usr/local/bin/ksh  
 #else  
51    SHELL=/bin/sh    SHELL=/bin/sh
52  #fi  vsay $this: Using shell $SHELL.
 echo "  using $SHELL"  
53    
54  #  #
55  # set the SML root directory  # set the SML root directory
56  #  #
57  REAL_PWD=`pwd`  REAL_PWD=`pwd`
58  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
59  echo "SML root is $ROOT"  vsay $this: SML root is $ROOT.
60    
61    cd ${INSTALLDIR:=$ROOT}
62    INSTALLDIR=`pwd`
63    cd $ROOT
64    vsay $this: Installation directory is ${INSTALLDIR}.
65    
66  #  #
67  # set the various directory pathname variables  # set the various directory and file pathname variables
68  #  #
69  BINDIR=$ROOT/bin  BINDIR=$INSTALLDIR/bin          # main dir for binary stuff
70  CONFIGDIR=$ROOT/config  CONFIGDIR=$ROOT/config
71  HEAPDIR=$BINDIR/.heap  HEAPDIR=$BINDIR/.heap           # where heap images live
72  RUNDIR=$BINDIR/.run  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
73  SRCDIR=$ROOT/src  SRCDIR=$ROOT/src                # where the source tree is rooted
74  LIBDIR=$ROOT/lib  LIBDIR=$INSTALLDIR/lib          # where libraries live
75    
76  #  #
77  # the paths to ml-yacc and ml-lex; needed to configure CM  # files to be deleted after we are done...
78    #
79    tmpfiles=""
80    tmpfiles="$tmpfiles $ROOT/preloads.standard"
81    #
82    # make sure we always clean up after ourselves...
83  #  #
84  YACCPATH=$BINDIR/ml-yacc  trap 'rm -f $tmpfiles' 0 1 2 3 15
85  LEXPATH=$BINDIR/ml-lex  
 BURGPATH=$BINDIR/ml-burg  
86    
87  #  #
88  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
89  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
90  #  -M.Blume (5/1998)  # Especially important is CM_PATHCONFIG.
91  #  #
92  CM_YACC_DEFAULT=$YACCPATH  CM_PATHCONFIG=$LIBDIR/pathconfig
93  CM_LEX_DEFAULT=$LEXPATH  export CM_PATHCONFIG
 CM_BURG_DEFAULT=$BURGPATH  
 CM_PATH_DEFAULT=.:$LIBDIR  
 export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATH_DEFAULT  
94    
95  #  #
96  # the release version that we are installing  # the release version that we are installing
97  #  #
98  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat $CONFIGDIR/version`
99  echo "installing version $VERSION"  vsay $this: Installing version $VERSION.
100    
101  #  #
102  # create the various sub directories  # the URL for the (usually remote) source archive
103  #  #
104  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`
105  do  vsay $this: URL of source archive is $SRCARCHIVEURL.
106    if [ -d $dir ]; then  
107      echo "$dir already exists"  #
108    else  # Function to make a directory including its ancestors.
109      echo "creating $dir"  #
110      mkdir $dir  makedir() {
111      if [ $? != "0" ]; then      if [ x$1 = x ] ; then
112        echo "unable to create $dir"          :
113        exit 1      elif [ -d $1 ] ; then
114            :
115        else
116            makedir `dirname $1`
117            if [ x${INSTALL_VERBOSE} = xtrue ] ; then
118                vsay "$this: Making directory $1"
119      fi      fi
120            if mkdir $1 ; then
121                :
122            else
123                complain "$this: !!! Unable to make directory $1!"
124    fi    fi
125  done      fi
126    }
127    
128  #  #
129  # install the script that tests the architecture, and make sure that it works  # Fish out the CM metadata directory name from library files
130    # and store it in ORIG_CM_DIR_ARC.
131    # The single argument is the name of the directory containing
132    # a single subdirectory which is a CM metadata directory:
133  #  #
134  if [ -x $BINDIR/.arch-n-opsys ]; then  fish() {
135    echo "$BINDIR/.arch-n-opsys already exists"      cd $1
136        ORIG_CM_DIR_ARC=unknown
137        for i in * .[a-zA-Z0-9]* ; do
138            if [ -d $i ] ; then
139                ORIG_CM_DIR_ARC=$i
140                break
141            fi
142        done
143        if [ $ORIG_CM_DIR_ARC = unknown ] ; then
144            complain "$this: could not determine CM metadata directory name"
145  else  else
146    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys          echo "$this: CM metadata directory name is \"${ORIG_CM_DIR_ARC}\""
147    chmod 555 $BINDIR/.arch-n-opsys      fi
148    if [ ! -x $BINDIR/.arch-n-opsys ]; then  }
149      echo "!!! installation of $BINDIR/.arch-n-opsys failed for some reason"  
150      exit 1  
151    # A function to move all stable library files to a parallel directory
152    # hierarchy.
153    # The first argument must be a simple path (no / inside), and
154    # the second argument must be an absolute path.
155    move() {
156        if [ -L $1 ] ; then
157            rm -f $1             # remove symbolic link made by diracs (see below)
158        elif [ -d $1 ] ; then
159            if [ ! -d $2 ] ; then
160                if [ -f $2 ] ; then
161                    complain $this: $2 exists as a non-directory.
162                fi
163                mkdir $2
164            fi
165            cd $1
166            for i in * .[a-zA-Z0-9]* ; do
167                move $i $2/$i
168            done
169            cd ..
170        elif [ -f $1 ] ; then
171            rm -f $2
172            mv $1 $2
173        fi
174    }
175    
176    #
177    # Traverse the directory tree rooted at $3 (must be single arc!).
178    # Find all directories named $1, rename them into $2 and make
179    # and establish $1 as a symbolic link to $2:
180    #
181    dirarcs() {
182        if [ -d $3 ] ; then
183            if [ $3 = $1 ] ; then
184                mv $1 $2
185                ln -s $2 $1
186            else
187                cd $3
188                for d in * .[a-zA-Z0-9]* ; do
189                    dirarcs $1 $2 $d
190                done
191                cd ..
192    fi    fi
193  fi  fi
194    }
195    
196    
197    ######################################################################
198    
199    #
200    # create the various sub directories
201    #
202    for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR ; do
203        makedir $dir
204    done
205    
206    #
207    # Function to install a "driver" script...
208    #   This takes care of patching the source of the script with the SHELL,
209    #   BINDIR, and VERSION variables to use.
210    #
211    installdriver() {
212        dsrc=$1
213        ddst=$2
214    # We install the driver unconditionally. (It would be better to test
215    # for an outdated driver script, but not all "test" commands understand
216    # the -nt comparison operator....)
217    #   if [ -x $BINDIR/$ddst ]; then
218    #       echo $this: Script $BINDIR/$ddst already exists.
219    #   else
220            rm -f $BINDIR/$ddst
221            cat $CONFIGDIR/$dsrc | \
222            sed -e "s,@SHELL@,$SHELL,g" \
223                -e "s,@BINDIR@,$BINDIR," \
224                -e "s,@VERSION@,$VERSION," \
225                -e "s,@CMDIRARC@,${CM_DIR_ARC:-dummy}," \
226                > $BINDIR/$ddst
227            chmod 555 $BINDIR/$ddst
228            if [ ! -x $BINDIR/$ddst ]; then
229                complain "$this: !!! Installation of $BINDIR/${ddst} failed."
230            fi
231    #   fi
232    }
233    
234    #
235    # install the script that tests architecture and os...
236    #
237    installdriver _arch-n-opsys .arch-n-opsys
238    
239    #
240    # run it to figure out what architecture and os we are using, define
241    # corresponding variables...
242    #
243  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
244  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
245    echo "!!! $BINDIR/.arch-n-opsys fails on this machine"      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
246    echo "!!! you must patch this by hand and repeat the installation"      echo "$this: !!! You must patch this by hand and repeat the installation."
247    exit 2    exit 2
248  else  else
249    echo "$BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS"      vsay $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
250  fi  fi
251  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
252    
253  if [ -x $BINDIR/.run-sml ]; then  #
254    echo "$BINDIR/.run-sml already exists"  # now install most of the other driver scripts
255  else  #  (except ml-build, since we don't know $CM_DIR_ARC yet)
256    cat $CONFIGDIR/_run-sml | \  #
257      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  installdriver _run-sml .run-sml
258      > $BINDIR/.run-sml  installdriver _link-sml .link-sml
259    chmod 555 $BINDIR/.run-sml  installdriver _ml-makedepend ml-makedepend
   if [ ! -x $BINDIR/.run-sml ]; then  
     echo "!!! installation of $BINDIR/.run-sml failed for some reason"  
     exit 1  
   fi  
 fi  
260    
261  #  #
262  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
263  #  #
264  case $ARCH in  case $ARCH in
265    mips*) ALLOC=1M ;;      mips*)
266            ALLOC=1M
267            ;;
268    x86)    x86)
269            # The following is the _wrong_ value for many popular x86 chips
270            # (i.e., Celerons).  However, the optimal value for those is 32k,
271            # and such a small value is not enough for the runtime system's boot
272            # code.  Therefore, we use 256k here and re-set it to the proper
273            # value in .run-sml.
274      ALLOC=256k      ALLOC=256k
275    ;;    ;;
276    alpha32)    alpha32)
# Line 155  Line 280 
280      ALLOC=512k      ALLOC=512k
281    ;;    ;;
282  esac  esac
283    
284  case $OPSYS in  case $OPSYS in
285    solaris)    solaris)
286      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 162  Line 288 
288    linux)    linux)
289      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
290      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
291        echo "problems checking for underscores in global names"              complain "$this: !!! Problems checking for underscores in asm names."
       exit 1  
292      fi      fi
293      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
294    ;;    ;;
# Line 172  Line 297 
297  #  #
298  # the name of the bin files directory  # the name of the bin files directory
299  #  #
300  BIN_FILES=bin.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
301    BOOT_FILES=sml.$BOOT_ARCHIVE
302    
303  #  #
304  # build the run-time system  # build the run-time system
305  #  #
306  $CONFIGDIR/unpack.sh "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime.tar  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
307  if [ "$?" != "0" ]; then      vsay $this: Run-time system already exists.
308    exit $?  else
309  fi      $CONFIGDIR/unpack $ROOT runtime
 if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then  
310    cd $SRCDIR/runtime/objs    cd $SRCDIR/runtime/objs
311    echo "compiling the run-time system"      echo $this: Compiling the run-time system.
312    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
313    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
314      mv run.$ARCH-$OPSYS $RUNDIR      mv run.$ARCH-$OPSYS $RUNDIR
315      $MAKE MAKE=$MAKE clean      $MAKE MAKE=$MAKE clean
316    else    else
317      echo "!!! run-time system build failed for some reason"          complain "$this: !!! Run-time system build failed for some reason."
     exit 1  
318    fi    fi
319  fi  fi
320  cd $SRCDIR  cd $SRCDIR
# Line 199  Line 323 
323  # boot the base SML system  # boot the base SML system
324  #  #
325  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
326    echo "$HEAPDIR/sml.$HEAP_SUFFIX already exists"      vsay $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
327        fish $LIBDIR/basis.cm
328        # ignore requested arc name since we have to live with what is there:
329        export CM_DIR_ARC=$ORIG_CM_DIR_ARC
330  else  else
331    $CONFIGDIR/unpack.sh bin $ROOT $BIN_FILES $ROOT/$VERSION-$BIN_FILES.tar      $CONFIGDIR/unpack $ROOT $BOOT_ARCHIVE
332    
333        fish $ROOT/$BOOT_FILES/basis.cm
334    
335    cd $ROOT    cd $ROOT
336    $RUNDIR/run.$ARCH-$OPSYS @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
337      $SET_FLAGS      # Target arc:
338      val use = Compiler.Interact.useFile      export CM_DIR_ARC=${CM_DIR_ARC:-".cm"}
339      val _ = (SMLofNJ.exportML "sml";  
340               print Compiler.banner;      if [ $CM_DIR_ARC = $ORIG_CM_DIR_ARC ] ; then
341               print "\n");          : we are happy
 XXXX  
   if [ -r sml.$HEAP_SUFFIX ]; then  
     mv sml.$HEAP_SUFFIX $HEAPDIR  
     cd $BINDIR  
     ln -s .run-sml sml  
342    else    else
343      echo "!!! unable to build SML heap image (sml.$HEAP_SUFFIX)"          # now we have to make a symbolic link for each occurrence of
344      exit 1          # $ORIG_CM_DIR_ARC to $CM_DIR_ARC
345    fi          dirarcs ${ORIG_CM_DIR_ARC} ${CM_DIR_ARC} $BOOT_FILES
346  fi  fi
347    
348        cd $ROOT/$BOOT_FILES
349    
350        # now link (boot) the system and let it initialize itself...
351        if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
352        then
353            cd $ROOT
354            if [ -r sml.$HEAP_SUFFIX ]; then
355                mv sml.$HEAP_SUFFIX $HEAPDIR
356                cd $BINDIR
357                ln -s .run-sml sml
358  #  #
359  # now build the individual targets              # Now move all stable libraries to #LIBDIR and generate
360                # the pathconfig file.
361  #  #
362  cd $SRCDIR              cd $ROOT/$BOOT_FILES
363  echo "install targets"              for anchor in * ; do
364  for i in $TARGETS                  if [ -d $anchor ] ; then
365  do                      echo $anchor $anchor >>$CM_PATHCONFIG
366    if [ $i = "doc" ]; then                      move $anchor $LIBDIR/$anchor
367      TARGET=$i                  fi
   else  
     TARGET=$i.$HEAP_SUFFIX  
   fi  
   if [ -r $HEAPDIR/$TARGET ]; then  
     echo "$TARGET already exists"  
   else  
     echo "  building $TARGET"  
     case $i in  
       src-smlnj)  
         for src in compiler comp-lib cm MLRISC; do  
           $CONFIGDIR/unpack.sh $src $ROOT/src $src $ROOT/$VERSION-$src.tar  
368          done          done
       ;;  
       sml-full)  
         if [ ! -d $ROOT/$BIN_FILES ]; then  
           echo "!!! bin files are missing; build of $TARGET failed"  
           exit 1  
         else  
369            cd $ROOT            cd $ROOT
370            $RUNDIR/run.$ARCH-$OPSYS @SMLfull @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
371              $SET_FLAGS              rm -rf $BOOT_FILES
372              val use = Compiler.Interact.useFile  
             val _ = (SMLofNJ.exportML "sml-full";  
                      print Compiler.banner;  
                      print " [full]\n");  
 XXXX  
           if [ -r sml-full.$HEAP_SUFFIX ]; then  
             mv sml-full.$HEAP_SUFFIX $HEAPDIR  
             cd $BINDIR  
             ln -s .run-sml sml-full  
           else  
             echo "!!! unable to build SML-FULL heap image"  
             exit 1  
           fi  
         fi  
       ;;  
       ml-yacc)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc  
         ./build  
         if [ -r src/$TARGET ]; then  
           mv src/$TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
       ;;  
       ml-lex)  
         $CONFIGDIR/unpack.sh ML-Lex $SRCDIR ml-lex $ROOT/$VERSION-ml-lex.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-lex  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
373          else          else
374            echo "!!! build of $TARGET failed"              complain "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
           exit 1  
         fi  
       ;;  
       ml-burg)  
         $CONFIGDIR/unpack.sh ML-Burg $SRCDIR ml-burg $ROOT/$VERSION-ml-burg.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-burg  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
375            fi            fi
376          else          else
377            echo "!!! build of $TARGET failed"          complain "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
           exit 1  
         fi  
       ;;  
       smlnj-lib)  
         $CONFIGDIR/unpack.sh "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
       # make the Util library  
         cd $SRCDIR/smlnj-lib/Util  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/smlnj-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Util/sources.cm" > smlnj-lib.cm  
         fi  
       # make the Unix library  
         cd $SRCDIR/smlnj-lib/Unix  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/unix-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Unix/sources.cm" > unix-lib.cm  
         fi  
       # make the HTML library  
         cd $SRCDIR/smlnj-lib/HTML  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/html-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/HTML/sources.cm" > html-lib.cm  
         fi  
       # make the Reactive library  
         cd $SRCDIR/smlnj-lib/Reactive  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/reactive-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Reactive/sources.cm" > reactive-lib.cm  
         fi  
       # make the PP library  
         cd $SRCDIR/smlnj-lib/PP  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/pp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/PP/sources.cm" > pp-lib.cm  
         fi  
       # make the RegExp library  
         cd $SRCDIR/smlnj-lib/RegExp  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/regexp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/RegExp/sources.cm" > regexp-lib.cm  
         fi  
       ;;  
       ml-yacc-lib)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc/lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/ml-yacc-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/ml-yacc/lib/sources.cm" > ml-yacc-lib.cm  
         fi  
       ;;  
       cml)  
         $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
378          fi          fi
         cd $SRCDIR/cml/src  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/src/sources.cm" > cml.cm  
379          fi          fi
       ;;  
       cml-lib)  
         $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/cml/cml-lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/cml-lib/sources.cm" > cml-lib.cm  
         fi  
       ;;  
       cml-cm)  
         CMD="CM.autoloading(SOME true); CM.clearAutoList();"  
         CMD="$CMD CM.autoload'(\"$LIBDIR/cml.cm\");"  
         if [ "$AUTOLOAD_CML_LIB" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/cml-lib.cm\");"  
         fi  
         if [ "$AUTOLOAD_EXENE" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/eXene.cm\");"  
         fi  
         cd $ROOT  
         $BINDIR/sml <<XXXX  
           $CMD  
           val _ = (SMLofNJ.exportML "$i";  
                 print CML.banner;  
                 print "[CML autoload]\n");  
 XXXX  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! unable to build autoloading CML"  
           exit 1  
         fi  
       ;;  
       eXene)  
         $CONFIGDIR/unpack.sh EXene $SRCDIR eXene $ROOT/$VERSION-eXene.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/eXene  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/eXene.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/eXene/sources.cm" > eXene.cm  
         fi  
       ;;  
       doc)  
         $CONFIGDIR/unpack.sh Doc $ROOT doc $ROOT/$VERSION-doc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $ROOT/doc  
         build $ROOT  
       ;;  
       *)  
         echo "!!! unknown target $i"  
       ;;  
     esac  
   fi  
 done  
380    
381  if [ "$ENABLE_AUTOLOADING" = "TRUE" ]; then  #
382    CMD="CM.autoloading(SOME true); CM.clearAutoList();"  # now that we know CM_DIR_ARC we can install the ml-build driver...
383    if [ "$AUTOLOAD_SMLNJ_LIB" = "TRUE" ]; then  #
384      CMD="$CMD CM.autoload'(\"$LIBDIR/smlnj-lib.cm\");"  installdriver _ml-build ml-build
385    fi  
   if [ "$AUTOLOAD_SMLNJ_UNIX" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/unix-lib.cm\");"  
   fi  
   if [ "$AUTOLOAD_SMLNJ_HTML" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/html-lib.cm\");"  
   fi  
   if [ "$AUTOLOAD_SMLNJ_REACTIVE" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/reactive-lib.cm\");"  
   fi  
   if [ "AUTOLOAD_SMLNJ_PP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/pp-lib.cm\");"  
   fi  
   if [ "AUTOLOAD_SMLNJ_REGEXP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/regexp-lib.cm\");"  
   fi  
386    cd $ROOT    cd $ROOT
387    $BINDIR/sml <<XXXX  
388      $CMD  #
389      val _ = (SMLofNJ.exportML "sml";  # Now do all the rest using the precompiled installer:
390               print Compiler.banner;  #
391               print " [CM; autoload enabled]\n");  echo $this: Installing other libraries and programs:
392  XXXX  export ROOT INSTALLDIR CONFIGDIR BINDIR
393    if [ -r sml.$HEAP_SUFFIX ]; then  if $BINDIR/sml -m \$smlnj/installer.cm
394      mv sml.$HEAP_SUFFIX $HEAPDIR  then
395        vsay $this: Installation complete.
396    else    else
397      echo "!!! unable to build SML with autoloading"      complain "$this: !!! Installation of libraries and programs failed."
     exit 1  
   fi  
398  fi  fi
399    
400    exit 0

Legend:
Removed from v.249  
changed lines
  Added in v.1494

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0